"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

let _Symbol$species;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

_Symbol$species = Symbol.species;

class GokuArray extends Array {
  constructor(items, preserveNativeMethods) {
    if (items && items.length === 1 && typeof items[0] === 'number') {
      // avoiding new Array(x) that creates an array with a length of x
      super();

      _defineProperty(this, "toArray", () => [...this]);

      _defineProperty(this, "asyncMap", fn => // eslint-disable-next-line no-underscore-dangle
      GokuArray._reduce(this, async (acc, value, index, arr) => {
        acc.push((await fn(value, index, arr)));
      }, new GokuArray(), false));

      _defineProperty(this, "asyncFilter", async fn => // eslint-disable-next-line no-underscore-dangle
      GokuArray._reduce(this, async (acc, value, index, arr) => {
        if (await fn(value, index, arr)) acc.push(value);
      }, new GokuArray(), false));

      _defineProperty(this, "diff", (arr = []) => {
        const current = this;
        const next = arr;
        const additional = next.filter(item => !current.includes(item));
        const missing = current.filter(item => !next.includes(item));
        const common = current.filter(item => next.includes(item));
        return {
          additional: [...additional],
          // otherwise will be of type GokuArray
          missing: [...missing],
          // same as above
          common: [...new Set(common)]
        };
      });

      _defineProperty(this, "missingFrom", (arr = []) => {
        const array = this.filter(i => arr.indexOf(i) === -1);
        return new GokuArray(array);
      });

      _defineProperty(this, "unique", identity => {
        const uniq = typeof identity === 'function' ? this.filter(function unq(item) {
          const id = typeof identity(item) === 'undefined' ? Math.random() : identity(item);
          return this.has(id) ? false : (this.add(id), true);
        }, new Set()) : [...new Set(this)];
        return new GokuArray(uniq);
      });

      _defineProperty(this, "sortItems", ({
        ordering = 'ASC',
        field = null
      } = {}) => {
        const sorted = this.sort((a, b) => {
          if (!field) {
            if (typeof a === 'number') {
              if (ordering === 'ASC') {
                return a - b;
              }

              return b - a;
            }

            if (typeof a === 'string') {
              if (a < b) {
                const value = ordering === 'ASC' ? -1 : 1;
                return value;
              }

              if (a > b) {
                const value = ordering === 'ASC' ? 1 : -1;
                return value;
              } // names must be equal


              return 0;
            } // TODO: sort also date objects
            // use Object.prototype.toString.call(field) === '[object Date]'
            // return field.getTime() - field.getTime()

          } else if (typeof a === 'object') {
            if (typeof a[field] === 'number') {
              if (ordering === 'ASC') {
                return a[field] - b[field];
              }

              return b[field] - a[field];
            }

            if (typeof a[field] === 'string') {
              const nameA = a[field].toUpperCase();
              const nameB = b[field].toUpperCase();

              if (nameA < nameB) {
                const value = ordering === 'ASC' ? -1 : 1;
                return value;
              }

              if (nameA > nameB) {
                const value = ordering === 'ASC' ? 1 : -1;
                return value;
              } // names must be equal


              return 0;
            } // TODO: sort also date objects
            // use Object.prototype.toString.call(field) === '[object Date]'
            // return field.getTime() - field.getTime()

          }

          return 0; // do nothing;
        });
        return new GokuArray(sorted);
      });

      _defineProperty(this, "groupBy", key => this.reduce((oBKV, obj) => {
        if (typeof obj !== 'object' || obj === null || typeof obj === 'undefined') return oBKV;
        const objectsByKeyValue = oBKV;
        const value = obj[key];
        if (!value) return objectsByKeyValue;
        objectsByKeyValue[value] = (objectsByKeyValue[value] || []).concat(obj);
        return objectsByKeyValue;
      }, {}));

      this.push(items[0]);
    } else if (items && Array.isArray(items)) {
      super(...items);

      _defineProperty(this, "toArray", () => [...this]);

      _defineProperty(this, "asyncMap", fn => GokuArray._reduce(this, async (acc, value, index, arr) => {
        acc.push((await fn(value, index, arr)));
      }, new GokuArray(), false));

      _defineProperty(this, "asyncFilter", async fn => GokuArray._reduce(this, async (acc, value, index, arr) => {
        if (await fn(value, index, arr)) acc.push(value);
      }, new GokuArray(), false));

      _defineProperty(this, "diff", (arr = []) => {
        const current = this;
        const next = arr;
        const additional = next.filter(item => !current.includes(item));
        const missing = current.filter(item => !next.includes(item));
        const common = current.filter(item => next.includes(item));
        return {
          additional: [...additional],
          missing: [...missing],
          common: [...new Set(common)]
        };
      });

      _defineProperty(this, "missingFrom", (arr = []) => {
        const array = this.filter(i => arr.indexOf(i) === -1);
        return new GokuArray(array);
      });

      _defineProperty(this, "unique", identity => {
        const uniq = typeof identity === 'function' ? this.filter(function unq(item) {
          const id = typeof identity(item) === 'undefined' ? Math.random() : identity(item);
          return this.has(id) ? false : (this.add(id), true);
        }, new Set()) : [...new Set(this)];
        return new GokuArray(uniq);
      });

      _defineProperty(this, "sortItems", ({
        ordering = 'ASC',
        field = null
      } = {}) => {
        const sorted = this.sort((a, b) => {
          if (!field) {
            if (typeof a === 'number') {
              if (ordering === 'ASC') {
                return a - b;
              }

              return b - a;
            }

            if (typeof a === 'string') {
              if (a < b) {
                const value = ordering === 'ASC' ? -1 : 1;
                return value;
              }

              if (a > b) {
                const value = ordering === 'ASC' ? 1 : -1;
                return value;
              }

              return 0;
            }
          } else if (typeof a === 'object') {
            if (typeof a[field] === 'number') {
              if (ordering === 'ASC') {
                return a[field] - b[field];
              }

              return b[field] - a[field];
            }

            if (typeof a[field] === 'string') {
              const nameA = a[field].toUpperCase();
              const nameB = b[field].toUpperCase();

              if (nameA < nameB) {
                const value = ordering === 'ASC' ? -1 : 1;
                return value;
              }

              if (nameA > nameB) {
                const value = ordering === 'ASC' ? 1 : -1;
                return value;
              }

              return 0;
            }
          }

          return 0;
        });
        return new GokuArray(sorted);
      });

      _defineProperty(this, "groupBy", key => this.reduce((oBKV, obj) => {
        if (typeof obj !== 'object' || obj === null || typeof obj === 'undefined') return oBKV;
        const objectsByKeyValue = oBKV;
        const value = obj[key];
        if (!value) return objectsByKeyValue;
        objectsByKeyValue[value] = (objectsByKeyValue[value] || []).concat(obj);
        return objectsByKeyValue;
      }, {}));
    } else {
      super();

      _defineProperty(this, "toArray", () => [...this]);

      _defineProperty(this, "asyncMap", fn => GokuArray._reduce(this, async (acc, value, index, arr) => {
        acc.push((await fn(value, index, arr)));
      }, new GokuArray(), false));

      _defineProperty(this, "asyncFilter", async fn => GokuArray._reduce(this, async (acc, value, index, arr) => {
        if (await fn(value, index, arr)) acc.push(value);
      }, new GokuArray(), false));

      _defineProperty(this, "diff", (arr = []) => {
        const current = this;
        const next = arr;
        const additional = next.filter(item => !current.includes(item));
        const missing = current.filter(item => !next.includes(item));
        const common = current.filter(item => next.includes(item));
        return {
          additional: [...additional],
          missing: [...missing],
          common: [...new Set(common)]
        };
      });

      _defineProperty(this, "missingFrom", (arr = []) => {
        const array = this.filter(i => arr.indexOf(i) === -1);
        return new GokuArray(array);
      });

      _defineProperty(this, "unique", identity => {
        const uniq = typeof identity === 'function' ? this.filter(function unq(item) {
          const id = typeof identity(item) === 'undefined' ? Math.random() : identity(item);
          return this.has(id) ? false : (this.add(id), true);
        }, new Set()) : [...new Set(this)];
        return new GokuArray(uniq);
      });

      _defineProperty(this, "sortItems", ({
        ordering = 'ASC',
        field = null
      } = {}) => {
        const sorted = this.sort((a, b) => {
          if (!field) {
            if (typeof a === 'number') {
              if (ordering === 'ASC') {
                return a - b;
              }

              return b - a;
            }

            if (typeof a === 'string') {
              if (a < b) {
                const value = ordering === 'ASC' ? -1 : 1;
                return value;
              }

              if (a > b) {
                const value = ordering === 'ASC' ? 1 : -1;
                return value;
              }

              return 0;
            }
          } else if (typeof a === 'object') {
            if (typeof a[field] === 'number') {
              if (ordering === 'ASC') {
                return a[field] - b[field];
              }

              return b[field] - a[field];
            }

            if (typeof a[field] === 'string') {
              const nameA = a[field].toUpperCase();
              const nameB = b[field].toUpperCase();

              if (nameA < nameB) {
                const value = ordering === 'ASC' ? -1 : 1;
                return value;
              }

              if (nameA > nameB) {
                const value = ordering === 'ASC' ? 1 : -1;
                return value;
              }

              return 0;
            }
          }

          return 0;
        });
        return new GokuArray(sorted);
      });

      _defineProperty(this, "groupBy", key => this.reduce((oBKV, obj) => {
        if (typeof obj !== 'object' || obj === null || typeof obj === 'undefined') return oBKV;
        const objectsByKeyValue = oBKV;
        const value = obj[key];
        if (!value) return objectsByKeyValue;
        objectsByKeyValue[value] = (objectsByKeyValue[value] || []).concat(obj);
        return objectsByKeyValue;
      }, {}));
    }

    GokuArray.preserveNativeMethods = preserveNativeMethods;
    /** Async version of Array.prototype.reduce()
     *  await reduce(['/foo', '/bar', '/baz'], async (acc, v) => {
     *    acc[v] = await (await fetch(v)).json();
     *    return acc;
     *  }, {});
     */
  }

  // built-in methods will use this as the constructor if preserveNativeMethods flag is present
  static get [_Symbol$species]() {
    if (this.preserveNativeMethods) return Array;
    return this;
  }

}

_defineProperty(GokuArray, "_reduce", async (arr, fn, val, pure) => {
  // eslint-disable-next-line no-plusplus
  for (let i = 0; i < arr.length; i++) {
    // eslint-disable-next-line no-await-in-loop
    const v = await fn(val, arr[i], i, arr); // eslint-disable-next-line no-param-reassign

    if (pure !== false) val = v;
  }

  return val;
});

var _default = GokuArray;
exports.default = _default;